package cz.muni.fi.pb162.hw03.impl;

import cz.muni.fi.pb162.hw03.write.CharacerSerializer;
import cz.muni.fi.pb162.hw03.write.CharacterFileWriter;
import org.thymeleaf.TemplateEngine;
import org.thymeleaf.context.Context;
import org.thymeleaf.templateresolver.ClassLoaderTemplateResolver;

/**
 * Base class capable of serialising character into HTML string
 * @author Jakub Cechacek
 */
public abstract class AbstractHtmlWriter implements CharacerSerializer<String>, CharacterFileWriter {
    public static final String TEMPLATE = "/templates/character.html";

    @Override
    public String serialize(Character character) {
        ClassLoaderTemplateResolver tr = new ClassLoaderTemplateResolver();
        TemplateEngine templates = new TemplateEngine();
        templates.setTemplateResolver(tr);

        Context context = new Context();
        context.setVariable("character", character);
        return templates.process(TEMPLATE, context);
    }
}
